
#include <stdio.h>
#include <string.h>

#define MAX 6
typedef struct { char nome[80]; double nota; } t_dados;

t_dados v[MAX] = {
	{ "Joao",       7.0 },
	{ "Maria",     13.0 },
	{ "Carlos",    10.0 },
	{ "Manuel",    12.0 },
	{ "Ana",        5.0 },
	{ "Francisco", 19.0 }
	};


int ascendente( t_dados a, t_dados b )
{
	return strcmp(a.nome, b.nome) > 0;
}


int descendente( t_dados a, t_dados b )
{
	return strcmp(a.nome, b.nome) < 0;
}


void bubblesort( t_dados v[], int tam, int (*fora_de_ordem)(t_dados, t_dados) )
{
	int i, j;
	t_dados t;

	for( i=0; i<tam-1; i++ )
		{
		for( j=0; j<tam-1-i; j++ )
			{
			if( (*fora_de_ordem)(v[j], v[j+1]) )
				{
				t = v[j];
				v[j] = v[j+1];
				v[j+1] = t;
				}
			}
		}
}


int main()
{
	int i;

	bubblesort( v, MAX, ascendente );
	for( i=0; i<MAX; i++ )
		printf( "%-15s %5.1f\n", v[i].nome, v[i].nota );
	printf( "\n" );
	bubblesort( v, MAX, descendente );
	for( i=0; i<MAX; i++ )
		printf( "%-15s %5.1f\n", v[i].nome, v[i].nota );
	printf( "\n" );
	return 0;
}
