#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>

#define MAX 26

struct jogador
	{
	char nome[10];
	int numero;
	};

typedef struct jogador JOGADOR;

JOGADOR tentativas[MAX] = {
	{ "A", 0 },
	{ "B", 0 },
	{ "C", 0 },
	{ "D", 0 },
	{ "E", 0 },
	{ "F", 0 },
	{ "G", 0 },
	{ "H", 0 },
	{ "I", 0 },
	{ "J", 0 },
	{ "K", 0 },
	{ "L", 0 },
	{ "M", 0 },
	{ "N", 0 },
	{ "O", 0 },
	{ "P", 0 },
	{ "Q", 0 },
	{ "R", 0 },
	{ "S", 0 },
	{ "T", 0 },
	{ "U", 0 },
	{ "V", 0 },
	{ "W", 0 },
	{ "X", 0 },
	{ "Y", 0 },
	{ "Z", 0 }
	};

int num_random;


int cmp( JOGADOR a, JOGADOR b )
{
	int dist_a, dist_b;

	dist_a = abs( a.numero - num_random );
	dist_b = abs( b.numero - num_random );

	return dist_a < dist_b;
}


void bubblesort( JOGADOR v[], int tam, int (*em_ordem)(JOGADOR,JOGADOR) )
{
	int i, j;
	JOGADOR t;

	for( i=0; i<tam-1; i++ )
		{
		for( j=0; j<tam-1-i; j++ )
			{
			if( !(*em_ordem)(v[j],v[j+1]) )
				{
				t = v[j];
				v[j] = v[j+1];
				v[j+1] = t;
				}
			}
		}
}


int main()
{
	int num_jogadores, i, acertou;

	for(;;)	{
		printf( "Quantos jogadores? " );
		scanf( "%d", &num_jogadores );
		if( num_jogadores >= 1  &&  num_jogadores <= MAX )
			break;
		printf( "A quantidade de jogadores  invlida (max. %d)!\n", MAX );
		}

	srand( (unsigned int) time(NULL) );
	num_random = 1 + rand() % 100;
	printf( "Calculei um numero aleatorio entre 1 e 100 (inclusive)\n" );

	for(;;)	{
		for( i=0;  i < num_jogadores;  i++ )
			{
			printf( "Aposta do jogador %s: ", tentativas[i].nome );
			scanf( "%d", &tentativas[i].numero );
			}
		printf( "\n" );

		acertou = 0;
		for( i=0;  i < num_jogadores;  i++ )
			{
			if( tentativas[i].numero == num_random )
				{
				printf( "O jogador %s acertou!!\n", tentativas[i].nome );
				acertou = 1;
				}
			}
		if( acertou )
			break;

		bubblesort( tentativas, num_jogadores, cmp );
		printf( "Os jogadores, ordenados por proximidade, sao:\n" );
		for( i=0;  i < num_jogadores;  i++ )
			{
			printf( "%s\n", tentativas[i].nome );
			}
		printf( "Os jogadores voltam a jogar por esta ordem.\n\n" );
		}

	return 0;
}
